Whamcloud - gitweb
b=17839
[fs/lustre-release.git] / lustre / tests / recovery-mds-scale.sh
1 #!/bin/bash
2
3 # Was Test 11 in cmd3.
4 # For duration of 24 hours repeatedly failover a random MDS at
5 # 10 minute intervals and verify that no application errors occur.
6
7 # Test runs one of CLIENT_LOAD progs on remote clients.
8
9 LUSTRE=${LUSTRE:-`dirname $0`/..}
10 SETUP=${SETUP:-""}
11 CLEANUP=${CLEANUP:-""}
12 . $LUSTRE/tests/test-framework.sh
13
14 init_test_env $@
15
16 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
17
18 TESTSUITELOG=${TESTSUITELOG:-$TMP/recovery-mds-scale}
19 DEBUGLOG=$TESTSUITELOG.debug
20 exec 2>$DEBUGLOG
21 echo "--- env ---" >&2
22 env >&2
23 echo "--- env ---" >&2
24 set -x
25
26 [ "$SHARED_DIRECTORY" ] || \
27     { skip "$0: Empty SHARED_DIRECTORY" && exit 0; }
28
29 [ -n "$CLIENTS" ] || { skip "$0 Need two or more remote clients" && exit 0; }
30 [ $CLIENTCOUNT -ge 3 ] || \
31     { skip "$0 Need two or more clients, have $CLIENTCOUNT" && exit 0; }
32
33 END_RUN_FILE=${END_RUN_FILE:-$SHARED_DIRECTORY}/end_run_file}
34 LOAD_PID_FILE=${LOAD_PID_FILE:-$TMP/client-load.pid}
35
36 remote_mds_nodsh && skip "remote MDS with nodsh" && exit 0
37 remote_ost_nodsh && skip "remote OST with nodsh" && exit 0
38
39 build_test_filter
40
41 check_and_setup_lustre
42 rm -rf $DIR/[df][0-9]*
43
44 # the test node needs to be insulated from a lustre failure as much as possible,
45 # so not even loading the lustre modules is ideal.
46 # -- umount lustre
47 # -- remove hostname from clients list
48 zconf_umount $(hostname) $MOUNT
49 NODES_TO_USE=${NODES_TO_USE:-$CLIENTS}
50 NODES_TO_USE=$(exclude_item_from_list $NODES_TO_USE $(hostname))
51
52 check_progs_installed $NODES_TO_USE ${CLIENT_LOADS[@]}
53
54 MDTS=""
55 for ((i=1; i<=$MDSCOUNT; i++)) do
56     MDTS="$MDTS mds$i"
57 done
58 MDTS=$(comma_list $MDTS)
59
60 OSTS=""
61 for ((i=1; i<=$OSTCOUNT; i++)) do
62     OSTS="$OSTS ost$i"
63 done
64 OSTS=$(comma_list $OSTS)
65
66 ERRORS_OK=""    # No application failures should occur during this test.
67 FLAVOR=${FLAVOR:-"MDS"}
68
69 if [ "$FLAVOR" == "MDS" ]; then
70     SERVERS=$MDTS
71 else
72     SERVERS=$OSTS
73 fi
74  
75 if [ "$SLOW" = "no" ]; then
76     DURATION=${DURATION:-$((60 * 30))}
77     SERVER_FAILOVER_PERIOD=${SERVER_FAILOVER_PERIOD:-$((60 * 5))}
78 else
79     DURATION=${DURATION:-$((60 * 60 * 24))}
80     SERVER_FAILOVER_PERIOD=${SERVER_FAILOVER_PERIOD:-$((60 * 10))} # 10 minutes
81 fi
82
83 rm -f $END_RUN_FILE
84
85 vmstatLOG=${TESTSUITELOG}_$(basename $0 .sh).vmstat
86
87 server_numfailovers () {
88     local facet
89     local var
90
91     for facet in $MDTS ${OSTS//,/ }; do
92         var=${facet}_nums
93         val=${!var}
94         if [ "$val" ] ; then
95             echo "$facet failed  over  $val times"
96         fi
97     done
98 }
99
100 summary_and_cleanup () {
101
102     local rc=$?
103     local var
104     trap 0
105
106     # Having not empty END_RUN_FILE means the failed loads only
107     if [ -s $END_RUN_FILE ]; then
108         echo "Found the END_RUN_FILE file: $END_RUN_FILE"
109         cat $END_RUN_FILE
110         local END_RUN_NODE=
111         read END_RUN_NODE < $END_RUN_FILE
112
113     # a client load will end (i.e. fail) if it finds
114     # the end run file.  that does not mean that that client load
115     # actually failed though.  the first node in the END_RUN_NODE is
116     # the one we are really interested in.
117         if [ -n "$END_RUN_NODE" ]; then
118             var=${END_RUN_NODE}_load
119             echo "Client load failed on node $END_RUN_NODE" 
120             echo
121             echo "client $END_RUN_NODE load stdout and debug files :
122               ${TESTSUITELOG}_run_${!var}.sh-${END_RUN_NODE}
123               ${TESTSUITELOG}_run_${!var}.sh-${END_RUN_NODE}.debug"
124         fi
125         rc=1
126     fi
127      
128     echo $(date +'%F %H:%M:%S') Terminating clients loads ...
129     echo "$0" >> $END_RUN_FILE
130     local result=PASS
131     [ $rc -eq 0 ] || result=FAIL
132
133     log "Duraion:                $DURATION
134 Server failover period: $SERVER_FAILOVER_PERIOD seconds
135 Exited after:           $ELAPSED seconds
136 Number of failovers before exit:
137 $(server_numfailovers)
138 Status: $result: rc=$rc"
139
140     # stop the vmstats on the OSTs
141     if [ "$VMSTAT" ]; then
142         do_nodes $(comma_list $(osts_nodes)) "test -f /tmp/vmstat.pid && \
143             { kill -s TERM \$(cat /tmp/vmstat.pid); rm -f /tmp/vmstat.pid; \
144             gzip -f9 $vmstatLOG-\$(hostname); }"
145     fi
146
147     # make sure the client loads die
148     do_nodes $NODES_TO_USE "set -x; test -f $LOAD_PID_FILE && \
149         { kill -s TERM \$(cat $LOAD_PID_FILE) || true; }"
150
151     # and free up the pdshes that started them, if any are still around
152     if [ -n "$CLIENT_LOAD_PIDS" ]; then
153         kill $CLIENT_LOAD_PIDS || true
154         sleep 5
155         kill -9 $CLIENT_LOAD_PIDS || true
156     fi
157     [ $rc -eq 0 ] && zconf_mount $(hostname) $MOUNT
158
159     exit $rc
160 }
161
162 #
163 # MAIN 
164 #
165 log "-----============= $0 starting =============-----"
166
167 trap summary_and_cleanup EXIT INT
168
169 ELAPSED=0
170 NUM_FAILOVERS=0
171
172 # vmstat the osts
173 if [ "$VMSTAT" ]; then
174     do_nodes $(comma_list $(osts_nodes)) "vmstat 1 > $vmstatLOG-\$(hostname) 2>/dev/null </dev/null & echo \$! > /tmp/vmstat.pid"
175 fi
176
177 # Start client loads.
178 start_client_loads $NODES_TO_USE
179
180 echo clients load pids:
181 if ! do_nodes $NODES_TO_USE "set -x; echo \$(hostname): && cat $LOAD_PID_FILE"; then
182     if [ -e $DEBUGLOG ]; then
183         exec 2<&-
184         cat $DEBUGLOG
185         exit 3
186     fi
187 fi
188
189 START_TS=$(date +%s)
190 CURRENT_TS=$START_TS
191
192 MINSLEEP=${MINSLEEP:-120}
193 REQFAIL_PERCENT=${REQFAIL_PERCENT:-3}   # bug17839 comment 62
194 REQFAIL=${REQFAIL:-$(( DURATION / SERVER_FAILOVER_PERIOD * REQFAIL_PERCENT / 100))}
195 reqfail=0
196 sleep=0
197 while [ $ELAPSED -lt $DURATION -a ! -e $END_RUN_FILE ]; do
198
199     # In order to perform the 
200     # expected number of failovers, we need to account the following :
201     # 1) the time that has elapsed during the client load checking
202     # 2) time takes for failover
203
204     it_time_start=$(date +%s)
205     
206     SERVERFACET=$(get_random_entry $SERVERS)
207     var=${SERVERFACET}_nums
208
209     # Check that our client loads are still running. If any have died, 
210     # that means they have died outside of recovery, which is unacceptable.    
211
212     log "==== Checking the clients loads BEFORE failover -- failure NOT OK \
213     ELAPSED=$ELAPSED DURATION=$DURATION PERIOD=$SERVER_FAILOVER_PERIOD" 
214
215     if ! check_client_loads $NODES_TO_USE; then
216         exit 4
217     fi
218
219     log "Starting failover on $SERVERFACET"
220
221     facet_failover "$SERVERFACET" || exit 1
222
223     # Check that our client loads are still running during failover.
224     # No application failures should occur.
225
226     log "==== Checking the clients loads AFTER  failover -- failure NOT OK"
227     if ! check_client_loads $NODES_TO_USE; then
228         log "Client load failed during failover. Exiting"
229         exit 5
230     fi
231
232     # Increment the number of failovers
233     NUM_FAILOVERS=$((NUM_FAILOVERS+1))
234     val=$((${!var} + 1))
235     eval $var=$val
236  
237     CURRENT_TS=$(date +%s)
238     ELAPSED=$((CURRENT_TS - START_TS))
239  
240     sleep=$((SERVER_FAILOVER_PERIOD-(CURRENT_TS - it_time_start)))
241
242     # keep count the number of itterations when
243     # time spend to failover and two client loads check exceeded 
244     # the value ( SERVER_FAILOVER_PERIOD - MINSLEEP )
245     if [ $sleep -lt $MINSLEEP ]; then
246         reqfail=$((reqfail +1))
247         log "WARNING: failover and two check_client_loads time exceeded SERVER_FAILOVER_PERIOD - MINSLEEP !
248 Failed to meet interval $reqfail times ( REQFAIL=$REQFAIL ); have sleep=$sleep"
249         [ $reqfail -gt $REQFAIL ] && exit 6 
250     fi  
251
252     log "$SERVERFACET has failed over ${!var} times, and counting..."
253     if [ $sleep -gt 0 ]; then 
254         echo "sleeping $sleep seconds ... "
255         sleep $sleep
256     fi
257 done
258
259 exit 0